<template>
  <v-tooltip location="bottom" text="Benutzer bearbeiten">
    <template v-slot:activator="{ props }">
      <v-btn
        v-bind="props"
        icon="mdi-account-edit"
        density="comfortable"
        variant="text"
        color="success"
        @click="openDialog()"
      ></v-btn>
    </template>
  </v-tooltip>

  <v-dialog v-model="showDialog" max-width="600">
    <v-card prepend-icon="mdi-account" title="Benutzer bearbeiten">
      <v-card-text>
        <v-row dense>
          <v-col cols="12" sm="6">
            <v-text-field
              label="Vorname:*"
              v-model="form.firstName"
              required
            ></v-text-field>
          </v-col>

          <v-col cols="12" sm="6">
            <v-text-field
              label="Nachname:*"
              v-model="form.lastName"
              required
            ></v-text-field>
          </v-col>

          <v-col cols="12" sm="12">
            <v-text-field
              label="E-Mail Adresse:*"
              v-model="form.email"
              required
            ></v-text-field>
          </v-col>

          <v-col cols="12" sm="12">
            <v-text-field
              label="Telefon-Nummer:"
              v-model="form.phoneNumber"
              type="tel"
            ></v-text-field>
          </v-col>

          <v-col cols="12">
            <v-select
              v-model="form.roleIds"
              :items="roles"
              item-title="name"
              item-value="id"
              label="Rollen:"
              clearable
              chips
              multiple
            >
            </v-select>
          </v-col>
        </v-row>

        <small class="text-caption text-medium-emphasis">
          *kennzeichnet ein Pflichtfeld
        </small>
      </v-card-text>

      <v-divider></v-divider>

      <v-card-actions>
        <v-spacer></v-spacer>

        <div class="d-flex flex-row justify-space-between w-100">
          <v-btn text="Abbrechen" color="error" @click="showDialog = false"></v-btn>

          <v-btn
            text="Benutzer speichern"
            color="success"
            :disabled="isFormInvalid()"
            @click="submitForm()"
          ></v-btn>
        </div>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script setup lang="ts">
import { onMounted, ref } from "vue";
import { RoleResponse, UserBody, UserResponse, api } from "../api";

const props = defineProps<{ user: UserResponse }>();

const emits = defineEmits<{ (event: "submitted"): void }>();

const showDialog = ref<boolean>(false);

const roles = ref<RoleResponse[]>([]);

const form = ref<UserBody>({
  firstName: "",
  lastName: "",
  email: "",
  phoneNumber: undefined,
  roleIds: [],
});

function openDialog(): void {
  form.value = {
    firstName: props.user.firstName,
    lastName: props.user.lastName,
    email: props.user.email,
    phoneNumber: props.user.phoneNumber,
    roleIds: [],
  };

  showDialog.value = true;
}

function isFormInvalid(): boolean {
  const { firstName, lastName, email } = form.value;

  return firstName.length === 0 || lastName.length == 0 || email.length === 0;
}

function submitForm(): void {
  if (isFormInvalid()) {
    return;
  }
  api.users
    .patchUser(props.user.id, form.value)
    .then(() => {
      emits("submitted");
      showDialog.value = false;
    })
    .catch((error) => {
      console.error(error);
    });
}

async function loadRoles(): Promise<void> {
  const { data, status, statusText } = await api.roles.getAllRoles();

  if (status !== 200) {
    console.error(statusText);
    return;
  }
  roles.value = data;
}

onMounted(loadRoles);
</script>
